import processing.serial.*;
import processing.video.*;
Serial myPort;
int currentScreen = 1;  
PFont myFont;
float speed = 0.01;
int distFromArduino;
PImage  photo1;
PImage photo2;
PImage photo3;
PImage arrow;
int c1, c2;
String quotes;
Capture video;
PFont f;
int increment = 20;


void setup() {
  size(700, 500);
  //size(640, 480);
  myFont = createFont("Lucida Sans Demibold", 32);
  printArray(Serial.list());
  String portname=Serial.list()[1];
  println(portname);
  myPort = new Serial(this, portname, 9600);
  myPort.clear();
  myPort.bufferUntil('\n');
  photo1 = loadImage ("volcano.png");
  photo2 = loadImage ("oc.png");
  photo3 = loadImage("cloud2.png");
  arrow = loadImage("arrow1.png");
  c2 = color(81, 160, 213);
  c1 = color(#B8E2F2);
  noStroke();
  //video = new Capture(this, "pipeline:autovideosrc");
  //video.start();
  String q[]=loadStrings("einstein.txt");
  f= createFont("Monaco", 32);
  quotes="";
  for (int i=0; i<q.length; i++) {
    quotes+=q[i];
  }
  println(quotes.length());
}




void draw() {

  if (currentScreen == 1) {
    doIntroMode();
  } else if (currentScreen == 2) {
    doSecondScreen();
  } else if (currentScreen == 3) {
    doAnxietyMode();
  } else if (currentScreen == 4) {
    doAngerMode();
  } else {
    doHappinessMode();
  }
}




void doIntroMode() {
  background(255);
  noStroke();
  noLoop();
  for (int y = 20; y < height; y += random(30)) {
    for (int x = 30; x< random(width); x += 40 ) {
      fill(random (255), random (255), random(255), 80);
      ellipse (x, y, 80, 80);
    }
  }

  fill( 0, 0, 0);
  textFont(myFont);
  textSize(25);
  text("Interactive Therapy", width * 0.53, height/2.3);
  fill(200, 88, 100, 80);
  noStroke();
  rect( width * 0.65, height * 0.55, 120, 50, 15); //button
  fill(0, 0, 0);
  textSize(30);
  text("start", width * 0.68, height * 0.54 + 40); //start
}



void doSecondScreen() {
  background(255);
  noStroke();
  fill(0, 0, 0);
  textFont(myFont);
  textSize(35);
  text ("what do you feel?", width/4, 200);
  textSize(25);
  fill(10, 0, 40, 70);    
  rect(100, 275, 130, 50, 10); //for anxiety   
  fill(0, 0, 0);
  text ("anxiety", 120, 310);
  fill(250, 0, 0, 70);
  rect(300, 275, 100, 50, 10);//anger
  fill(0, 0, 0);    
  text ("anger", 315, 310);
  fill(10, 100, 40, 70); 
  rect(500, 275, 150, 50, 10);//hapiness 
  fill(0, 0, 0);
  text ("happiness", 510, 310);
  noLoop();
  for (int x = 30; x< width; x += 40 ) {

    fill(random (255), random (255), random(255), 80);
    ellipse (x, random(30), 100, 100);
  }

  for (int x = 30; x< width; x += 40 ) {

    fill(random (255), random (255), random(255), 80);
    ellipse (x, random (height-40, height-20), 100, 100);
  }
}




void doAnxietyMode() {
  setGradient(0, 0, width, height, c1, c2);
  textFont(myFont);
  fill(255);
  textSize(35);
  text("control the sea", 210, 130);
  image(arrow, 650, 10, 40, 40);
  if (myPort.available()>0) {
    distFromArduino = myPort.read();
  }
  int rectWidth = 6;

  for (int x = 0; x < width + 10; x += rectWidth) {
    float y = height/2;
    float noiseValue = noise(frameCount * speed + x * 0.001);
    noiseValue -= .5;
    //noiseValue *= mouseX;
    noiseValue *= distFromArduino;

    y += noiseValue;
    noStroke();
    fill(#89CFF0);
    rect(x, y +100, rectWidth, 50);
    fill(#9DD9F3);
    rect(x, y +60, rectWidth, 100);
    fill(#B8E2F2);
    rect(x, y +20, rectWidth, 100);
    fill(#77C3EC);
    rect(x, y -10, rectWidth, 60);
    fill(81, 160, 213);
    rect(x, y+200, rectWidth, 60);
    fill(120, 197, 239);
    rect(x, y + 150, rectWidth, 60);
  }
}


int num = 1;
void doAngerMode() {
  background(34, 48, 60);

  image(photo1, 30, 50, 680, 680);
  textFont(myFont);
  fill(255);
  textSize(25);
  text ("Press space \nas fast as you can", 20, 60);
  int r = num*10;
  stroke(223, 40, 6);
  strokeWeight(8);
  rect (20, 460, 660, 20, 15);
  fill(223, 40, 6, 90);
  noStroke();
  rect (20, height - 40, r, 20, 15);
  if (r > width - 40) {
    image(photo2, 195, 0);
    image(arrow, 650, 10, 40, 40);
  }
}

void keyTyped() {
  if (key == ' ') {
    num = num +1 ;

    println(num);
  }
}

void doHappinessMode() {
  background(255);
  if (video.available()) {
    video.read();
  }
  int letterIndex=0;
  video.loadPixels();
  for (int y=0; y<height; y+=increment) {
    for (int x=0; x<width; x+=increment) {
      int loc = (video.width-x - 1)+(y*width);
      color pix=video.pixels[loc];
      float dims=brightness(pix);
      dims=increment*(dims/255);
      fill(pix);
      textAlign(CENTER);
      textFont(f, dims*2);
      text(quotes.charAt(letterIndex), x, y);
      letterIndex++;
      if (letterIndex>=quotes.length())
        letterIndex=0;
    }
  }
  video.updatePixels();
  increment=(int)map(mouseX, 0, width, 5, 50);
}

void mousePressed() {

  if (currentScreen == 1) {
    if (mouseX >= 455 && mouseX<= 575 && mouseY >=275 && mouseY<= 325) {
      currentScreen = 2;
      loop();
    }
  }
  if (currentScreen == 2) {
    if (mouseX >= 100 && mouseX<= 230 && mouseY >=275 && mouseY<= 325) {
      currentScreen = 3;
      loop();
    } else if (mouseX >= 300 && mouseX<= 400 && mouseY >=275 && mouseY<= 325) {
      currentScreen = 4;
      loop();
      print("currentScreen");
    } else if (mouseX >= 500 && mouseX<= 650 && mouseY >=275 && mouseY<= 325) {
      currentScreen = 5;
      loop();
    }
  }

  if (currentScreen == 3) {
    if (mouseX >= 650 && mouseX<= 690 && mouseY >=10 && mouseY<= 50) {
      currentScreen = 2;
      loop();
    }
  }
  if (currentScreen == 4) {
    if (mouseX >= 650 && mouseX<= 690 && mouseY >=10 && mouseY<= 50) {
      print("kdjb");
      currentScreen = 2;
      loop();
    }
  }
}




void setGradient(int x, int y, float w, float h, color c1, color c2 ) {

  noFill();

  // Top to bottom gradient
  for (int i = y; i <= y+h; i++) {
    float inter = map(i, y, y+h, 0, 1);
    color c = lerpColor(c1, c2, inter);
    stroke(c);
    line(x, i, x+w, i);
  }
}



void serialEvent(Serial myPort) {
  String s=myPort.readStringUntil('\n'); //open port, read 
  s=trim(s);
  if (s!=null) { //not empty
    distFromArduino=(int)map(int(s), 1, 25, 0, width);
  }

  println(distFromArduino);
  println(s);
  myPort.write(num + "\n");
}
